<template>
  <div class="w-full">
    <div v-if="themeName === 'peru'">
      <el-scrollbar class="win-lose-mobile hidden-mobile-version">
        <template v-if="statementList.length === 0">
          <lazy-utils-not-found />
        </template>
        <div v-else>
          <el-radio-group
            v-model="selectedMonth"
            size="large"
            class="flex overflow-x-scroll flex-nowrap"
          >
            <el-radio-button
              v-for="(month, index) in monthFilterRange"
              :key="index"
              :label="month.MonthRange"
              border
              class="bg-background2 date-selector"
              @change="getStatmentByMonth(month)"
            >
              {{ month.MonthRange }}
              <img
                v-if="!isBK8Mobile"
                class="check-img absolute"
                :src="getAssetImage('assets/svg-icon/checked.svg')"
                alt="check"
              />
            </el-radio-button>
          </el-radio-group>
          <div
            v-if="isMobile"
            class="flex items-center time-notice-footer py-2"
          >
            <el-icon class="mx-1">
              <clock />
            </el-icon>
            <p>{{ $t("All_transactions_are_time_stamped_at_GMT-4") }}</p>
          </div>
          <el-card
            v-for="data in statementList"
            :key="data"
            shadow="always"
            class="mb-[8px]"
          >
            <div class="grid grid-cols-3 gap-2">
              <div>{{ $t("date") }}</div>
              <div class="col-span-2 text-right value-text font-[700]">
                {{ data.DateForDisplay }}
              </div>
              <div>{{ $t("winlose") }}</div>
              <div
                class="col-span-2 text-right value-text font-[700]"
                :class="`fc-${data.TotalColorForDisplay}`"
              >
                {{ data.TotalCommas }}
              </div>
              <div>{{ $t("commission") }}</div>
              <div class="col-span-2 text-right value-text font-[700]">
                {{ data.CommissionCommas }}
              </div>
            </div>
          </el-card>
        </div>
      </el-scrollbar>
      <el-scrollbar class="hidden-desktop-version">
        <div>
          <ui-radio-group
            v-model="selectedMonth"
            group-name="cryptocurrencyNetwork"
            class="flex gap-4 flex-wrap mb-4"
          >
            <ui-radio-button
              v-for="(month, index) in monthFilterRange"
              :key="index"
              :label="month.MonthRange"
              @change="getStatmentByMonth(month)"
            >
              <ui-check-button
                :text="month.MonthRange"
                variant="TEXT_ONLY"
                class="min-w-[147px] left-select"
                style="
                  --height: 48px;
                  --content-padding: 0 1rem;
                  --border-radius: 0.5rem;
                "
              />
            </ui-radio-button>
          </ui-radio-group>
          <el-table
            v-loading="isDataLoading"
            border
            :data="statementList"
            max-height="510"
          >
            <template #empty>
              <lazy-utils-not-found />
            </template>
            <el-table-column
              :label="$t('date')"
              min-width="100"
              align="center"
              header-align="center"
            >
              <template #default="scope">
                <span>{{ scope.row.DateForDisplay }}</span>
              </template>
            </el-table-column>
            <el-table-column
              :label="$t('winlose')"
              header-align="center"
              align="right"
            >
              <template #default="scope">
                <span :class="`fc-${scope.row.TotalColorForDisplay}`">{{
                  scope.row.TotalCommas
                }}</span>
              </template>
            </el-table-column>
            <el-table-column
              :label="$t('commission')"
              align="right"
              header-align="center"
            >
              <template #default="scope">
                <span>{{ scope.row.CommissionCommas }}</span>
              </template>
            </el-table-column>
          </el-table>
        </div>
      </el-scrollbar>
    </div>
    <div v-else>
      <div v-if="isMobile" class="win-lose-mobile">
        <template v-if="statementList.length === 0">
          <lazy-utils-not-found />
        </template>
        <div v-else>
          <div class="statement-time-notice p-2">
            <el-radio-group
              v-model="selectedMonth"
              size="large"
              class="grid grid-cols-3 gap-3"
            >
              <el-radio-button
                v-for="(month, index) in monthFilterRange"
                :key="index"
                :label="month.MonthRange"
                border
                class="bg-background2 date-selector"
                @change="getStatmentByMonth(month)"
              >
                {{ month.MonthRange }}
                <img
                  v-if="!isBK8Mobile"
                  class="check-img absolute"
                  :src="getAssetImage('assets/svg-icon/checked.svg')"
                  alt="check"
                />
              </el-radio-button>
            </el-radio-group>
            <div class="flex items-center time-notice-footer pt-2">
              <el-icon class="mx-1">
                <clock />
              </el-icon>
              <p>{{ $t("All_transactions_are_time_stamped_at_GMT-4") }}</p>
            </div>
          </div>
          <div
            class="flex flex-col gap-2 pb-2 pt-1"
            :class="[{ 'px-2': !isNoNeedPadding }]"
          >
            <el-card
              v-for="data in statementList"
              :key="data"
              shadow="never"
              class="winlost-card"
            >
              <div class="flex flex-col gap-1">
                <div class="flex justify-between">
                  <span>{{ $t("date") }}</span>
                  <span class="font-medium">
                    {{ data.DateForDisplay }}
                  </span>
                </div>
                <div class="flex justify-between">
                  <span>{{ $t("winlose") }}</span>
                  <span
                    class="font-medium text-sm"
                    :class="`fc-${data.TotalColorForDisplay}`"
                  >
                    {{ data.TotalCommas }}
                  </span>
                </div>
                <div class="flex justify-between">
                  <span>{{ $t("commission") }}</span>
                  <span class="font-medium text-sm">
                    {{ data.CommissionCommas }}
                  </span>
                </div>
              </div>
            </el-card>
          </div>
        </div>
      </div>
      <div v-else>
        <ui-radio-group
          v-model="selectedMonth"
          group-name="cryptocurrencyNetwork"
          class="flex gap-4 flex-wrap mb-4"
        >
          <ui-radio-button
            v-for="(month, index) in monthFilterRange"
            :key="index"
            :label="month.MonthRange"
            @change="getStatmentByMonth(month)"
          >
            <ui-check-button
              :text="month.MonthRange"
              variant="TEXT_ONLY"
              class="min-w-[147px] left-select"
              style="
                --height: 48px;
                --content-padding: 0 1rem;
                --border-radius: 0.5rem;
              "
            />
          </ui-radio-button>
        </ui-radio-group>
        <el-scrollbar>
          <div
            class="rounded-lg"
            :class="{ 'border-table-wrapper': statementList.length }"
          >
            <el-table
              v-loading="isDataLoading"
              border
              :data="statementList"
              height=" 510"
              class="winlose-desktop"
            >
              <template #empty>
                <lazy-utils-not-found />
              </template>
              <el-table-column
                :label="$t('date')"
                min-width="100"
                align="left"
                header-align="center"
              >
                <template #default="scope">
                  <span>{{ scope.row.DateForDisplay }}</span>
                </template>
              </el-table-column>
              <el-table-column
                :label="$t('winlose')"
                header-align="center"
                align="right"
              >
                <template #default="scope">
                  <span :class="`fc-${scope.row.TotalColorForDisplay}`">{{
                    scope.row.TotalCommas
                  }}</span>
                </template>
              </el-table-column>
              <el-table-column
                :label="$t('commission')"
                align="right"
                header-align="center"
              >
                <template #default="scope">
                  <span>{{ scope.row.CommissionCommas }}</span>
                </template>
              </el-table-column>
            </el-table>
          </div>
        </el-scrollbar>
      </div>
    </div>
    <div v-if="!isMobile" class="flex items-center time-notice-footer mt-4">
      <el-icon class="mx-1">
        <clock />
      </el-icon>
      <p>{{ $t("All_transactions_are_time_stamped_at_GMT-4") }}</p>
    </div>
  </div>
</template>

<script lang="ts" setup>
import { Clock } from "@element-plus/icons-vue";
import commonHelper from "@/utils/commonHelper";
import { store } from "~~/store";
import { useStatement } from "@/composables/statement";
definePageMeta({ alias: "/transaction-history" });

const {
  statementList,
  monthFilterRange,
  getStatmentByMonth,
  selectedMonth,
  isDataLoading,
} = useStatement();
const { getAssetImage } = commonHelper;
const isMobile = !useIsDesktop();
const isNoNeedPadding = computed(
  () =>
    store.state.selectedThemeName === "china" ||
    store.state.selectedThemeName === "modern"
);
const themeColor = computed(() =>
  store.state.companyThemePropertiesFromApi.ThemeProperties.find(
    (t) => t.HtmlId === "theme_color"
  )
);
const isBK8Mobile = computed(
  () =>
    themeColor.value &&
    isMobile &&
    themeColor.value.Text.toLowerCase() === "bk8"
);
const themeName = store.state.selectedThemeName;
</script>
<style scoped>
.win-lose-mobile :deep(.check-btn__check) {
  right: 0.5rem;
}
</style>
<style lang="scss">
.el-card.winlost-card {
  --el-card-border-radius: 8px;
  --el-card-padding: 16px;
  --el-card-border-color: var(--border);
  --el-card-bg-color: var(--background5);
  color: var(--text5);

  & > * {
    font-family: Roboto;
    font-size: 12px;
    font-weight: 400;
    line-height: 14.06px;
    text-align: left;
    color: var(--text5);
  }
}

[theme-color="bk8"] .win-lose-mobile {
  .el-card__body {
    background: var(--background1);
    .value-text {
      font-weight: bold;
    }
  }
  .date-selector,
  .date-selector.is-active {
    background: var(--background1);
    .el-radio-button__inner {
      background: transparent;
      display: flex !important;
      justify-content: center !important;
      &::before {
        display: none;
      }
    }
  }
}
.common-main {
  .win-lose-mobile {
    .is-active {
      .el-radio-button__inner {
        display: flex !important;
        justify-content: flex-start !important;
        padding-left: 5px !important;
      }
    }
    .el-radio-button__inner::before {
      right: 5px !important;
    }
    .check-img {
      bottom: 13px;
      right: 8px;
    }
  }
}
</style>
